      program main
c    
      use test_HierarchicalSolver
c
      implicit none
c
      INTERFACE
      subroutine run_HMS_FORTRAN(N_in,NZ_in,NZ_loc_in,
     .     IRN_loc_in,JCN_loc_in,A_loc_in,RHS_in)
      integer :: N_in
      integer :: NZ_in
      integer :: NZ_loc_in
      integer, dimension(:), pointer :: IRN_loc_in
      integer, dimension(:), pointer :: JCN_loc_in
      double precision, dimension(:), pointer :: A_loc_in
      double precision, dimension(:), pointer :: RHS_in
      end subroutine run_HMS_FORTRAN
      END INTERFACE
c
      include "mpif.h"
c
      integer :: N_in !global N
      integer :: NZ_in !global NZ
      integer :: NZ_loc_in !dimension of *_loc
      integer, dimension(:), pointer :: IRN_loc_in  !global rows on local MPI process
      integer, dimension(:), pointer :: JCN_loc_in   !global columns on local MPI process
      double precision, dimension(:), pointer :: A_loc_in
      double precision, dimension(:), pointer :: RHS_in
c
      integer :: i1,i2
c
      call mpi_init(i1)
c
c      call run_HMS_tests
c      stop
c
      call mpi_comm_size(MPI_COMM_WORLD,nrproc,i1)
      call mpi_comm_rank(MPI_COMM_WORLD,myrank,i2)
      N_in=9
      NZ_in=20
      NZ_loc_in=5
      allocate(IRN_loc_in(NZ_loc_in))
      allocate(JCN_loc_in(NZ_loc_in))
      allocate(A_loc_in(NZ_loc_in))
      if(myrank.eq.0)then
        IRN_loc_in =  (/1,2,3,1,3/)
        JCN_loc_in =  (/1,2,3,3,1/)
        A_loc_in =  (/1,1,1,0,-1/)
        allocate(RHS_in(9))
        RHS_in = (/0,0,0,0,0,0,0,0,1/)
      else if(myrank.eq.1)then
        IRN_loc_in =  (/3,4,5,3,5/)
        JCN_loc_in =  (/3,4,5,5,3/)
        A_loc_in =  (/1.d0,1.0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.2)then
        IRN_loc_in =  (/5,6,7,5,7/)
        JCN_loc_in =  (/5,6,7,7,5/)
        A_loc_in =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.3)then
        IRN_loc_in =  (/7,8,9,7,9/)
        JCN_loc_in =  (/7,8,9,9,7/)
        A_loc_in =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,0.d0/)
      endif      

      call run_HMS_FORTRAN
     .  (N_in,NZ_in,NZ_loc_in,
     .  IRN_loc_in,JCN_loc_in,A_loc_in,RHS_in)

      call mpi_finalize(i1)

      end




