/* Example program using the C interface to HMS 
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mpi.h"


extern void run_hms_c_(int*,int*,int*,int*,int*,double*,double*);


int main(int argc, char ** argv)
{
  int n = 9;
  int nz = 20;
  int nz_loc = 5;
  int* irn;
  int* jcn;
  double* a;
  double* rhs;

  int myrank, ierr, i, ires;
  ierr = MPI_Init(&argc, &argv);
  ierr = MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

  irn = malloc(nz_loc);
  jcn = malloc(nz_loc);
  a = malloc(nz_loc);
  rhs = malloc(n);
  if(myrank==0){
    //IRN_loc =  (/1,2,3,1,3/)
    irn[0]=1; irn[1]=2; irn[2]=3; irn[3]=1; irn[4]=3;
    //JCN_loc =  (/1,2,3,3,1/)
    jcn[0]=1; jcn[1]=2; jcn[2]=3; jcn[3]=3; jcn[4]=1;
    //A_loc =  (/1,1,1,0,-1/)
    a[0]=1; a[1]=1; a[2]=1; a[3]=0; a[4]=-1;
    //RHS = (/0,0,0,0,0,0,0,0,1/)
    for(i=0;i<9;i++)rhs[i]=0;
    rhs[8]=1;
  }
  else if(myrank==1) {
    //IRN_loc =  (/3,4,5,3,5/)
    irn[0]=3; irn[1]=4; irn[2]=5; irn[3]=3; irn[4]=5;
    //JCN_loc =  (/3,4,5,5,3/)
    jcn[0]=3; jcn[1]=4; jcn[2]=5; jcn[3]=5; jcn[4]=3;
    //A_loc =  (/1.d0,1.0/3.d0,1.d0,-1.d0,-1.d0/)
    a[0]=1.0; a[1]=1.0/3.0; a[2]=1.0; a[3]=-1; a[4]=-1.0;
   }
  else if(myrank==2){
    //IRN_loc =  (/5,6,7,5,7/)
    irn[0]=5; irn[1]=6; irn[2]=7; irn[3]=5; irn[4]=7;
    //JCN_loc =  (/5,6,7,7,5/)
    jcn[0]=5; jcn[1]=6; jcn[2]=7; jcn[3]=7; jcn[4]=5;
    //A_loc =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
    a[0]=1.0; a[1]=1.0/3.0; a[2]=1.0; a[3]=-1.0; a[4]=-1.0;
  }
  else if(myrank==3){
    //IRN_loc =  (/7,8,9,7,9/)
    irn[0]=7; irn[1]=8; irn[2]=9; irn[3]=7; irn[4]=9;
    //JCN_loc =  (/7,8,9,9,7/)
    jcn[0]=7; jcn[1]=8; jcn[2]=9; jcn[3]=9; jcn[4]=7;
    // A_loc =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,0.d0/)
    a[0]=1.0; a[1]=1.0/3.0; a[2]=1.0; a[3]=-1.0; a[4]=0.0;
  }
  //call solver
  run_hms_c_(&n,&nz,&nz_loc,irn,jcn,a,rhs);
  //finish
  //ierr = MPI_Finalize();
  return 0;
}
