      subroutine run_HMS_C(N_in,NZ_in,NZ_loc_in,
     .     IRN_loc_in,JCN_loc_in,A_loc_in,RHS_in)
      use HierarchicalSolver
      implicit none
      include "mpif.h"
      integer :: N_in
      integer :: NZ_in
      integer :: NZ_loc_in
c      integer, dimension(:), pointer :: IRN_loc_in
c      integer, dimension(:), pointer :: JCN_loc_in
c      double precision, dimension(:), pointer :: A_loc_in
c      double precision, dimension(:), pointer :: RHS_in
      integer, target :: IRN_loc_in(*)
      integer, target :: JCN_loc_in(*)
      double precision, target :: A_loc_in(*)
      double precision, target :: RHS_in(*)
c
      integer :: ierr,i,i1,i2

      call mpi_comm_size(MPI_COMM_WORLD,nrproc,i1)
      call mpi_comm_rank(MPI_COMM_WORLD,myrank,i2)

      N=N_in
      NZ=NZ_in
      NZ_loc=NZ_loc_in
      IRN_loc(1:NZ_loc)=>IRN_loc_in(1:NZ_loc)
      JCN_loc(1:NZ_loc)=>JCN_loc_in(1:NZ_loc)
      A_loc(1:NZ_loc)=>A_loc_in(1:NZ_loc)
      if(myrank.eq.0)then
        RHS(1:N)=>RHS_in(1:N)
      else
        nullify(RHS)
      endif
c
c      write(*,*)'NZ_loc',NZ_loc
c      write(*,*)'A_loc_in',A_loc_in(1:NZ_loc)
c      write(*,*)'A_loc',A_loc(1:NZ_loc)
c      write(*,*)'IRN_loc_in',IRN_loc_in(1:NZ_loc)
c      write(*,*)'IRN_loc',IRN_loc(1:NZ_loc)
c
      write(*,*)'call phaseI_1_create_communicators'
      call phaseI_1_create_communicators
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_2_create_local_mumps'
      call phaseI_2_create_local_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_3_translate_global_to_local'
      call phaseI_3_translate_global_to_local
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_3a_cleanup'
      call phaseI_3a_cleanup    
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_3prim_distribute_rhs'
      call phaseI_3prim_distribute_rhs
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_4_submit_Schur_to_mumps'
      call phaseI_4_submit_Schur_to_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_4a_cleanup'
      call phaseI_4a_cleanup
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_5_compute_Schur'
      call phaseI_5_compute_Schur
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_6_get_Schur'
      call phaseI_6_get_Schur
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_6prim_copy_local_system'
      call phaseI_6prim_copy_local_system
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_6a_cleanup_mumps'
      call phaseI_6a_cleanup_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_7_create_global_mumps'
      call phaseI_7_create_global_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_8_submit_Schur_to_global_mumps'      
      call phaseI_8_submit_Schur_to_global_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_8a_cleanup'
      call phaseI_8a_cleanup
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_9_global_solution'
      call phaseI_9_global_solution
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_10_scatter_solution'
      call phaseI_10_scatter_solution
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_10a_cleanup_global_mumps'
      call phaseI_10a_cleanup_global_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)      
      write(*,*)'call phaseI_11_initialize_mumps_for_local_solve'
      call phaseI_11_initialize_mumps_for_local_solve
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_12_submit_problem_to_mumps'
      call phaseI_12_submit_problem_to_mumps
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_12a_cleanup'
      call phaseI_12a_cleanup
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_13_compute'
      call phaseI_13_compute
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_14_return_solution'
      call phaseI_14_return_solution
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      write(*,*)'call phaseI_14a_shutdown'
      call phaseI_14a_shutdown
      if(myrank.eq.0)write(*,*)'SOLUTION',RHS
      end subroutine run_HMS_C
