      module test_HierarchicalSolver
      use HierarchicalSolver

      logical, dimension(:), pointer :: testing_INTERFACE_loc 
      double precision, dimension(:), pointer :: test_RHS 
      integer, dimension(:), pointer :: test_mapl2g 
      integer, dimension(:), pointer :: test_mapsl2g 
      integer, dimension(:), pointer :: test_maps_sizes 
      integer, dimension(:), pointer :: test_IRN_loc
      integer, dimension(:), pointer :: test_JCN_loc
      integer, dimension(:), pointer :: test_IRN
      integer, dimension(:), pointer :: test_JCN
      double precision, dimension(:), pointer :: test_A_loc
      double precision, dimension(:), pointer :: test_A
      integer, dimension(:), pointer :: test_IRN_loc_sorted 
      integer, dimension(:), pointer :: test_IRN_loc_sorted_ptr 
      integer, dimension(:), pointer :: test_JCN_loc_sorted 
      integer, dimension(:), pointer :: test_JCN_loc_sorted_ptr 
      logical, dimension(:), pointer :: test_INTERFACE_loc_sorted 
      integer, dimension(:), pointer :: test_SCHUR_IRN_loc 
      integer, dimension(:), pointer :: test_SCHUR_JCN_loc 
      double precision, dimension(:), pointer :: test_SCHUR_A_loc 
      double precision, dimension(:), pointer :: test_SCHUR_RHS_loc 
      double precision, dimension(:), pointer :: test_RHS_loc 
      double precision, dimension(:), pointer :: test_SOL_loc 
      integer, dimension(:), pointer :: test_LISTVAR_SCHUR 
      double precision, dimension(:), pointer :: test_SCHUR

      contains

c-----------------------------------------------------------------------
      subroutine fill_interface
      include "mpif.h"
      integer :: i1,i2
      call mpi_comm_size(MPI_COMM_WORLD,nrproc,i1)
      call mpi_comm_rank(MPI_COMM_WORLD,myrank,i2)
      N=9
      NZ=20
      NZ_loc=5
      allocate(IRN_loc(NZ_loc))
      allocate(JCN_loc(NZ_loc))
      allocate(A_loc(NZ_loc))
c      allocate(INTERFACE_loc(NZ_loc))
      if(myrank.eq.0)then
        IRN_loc =  (/1,2,3,1,3/)
c        INTERFACE_loc =  (/.true.,.false.,.true.,.true.,.true./)
        JCN_loc =  (/1,2,3,3,1/)
        A_loc =  (/1,1,1,0,-1/)
        allocate(RHS(9))
        RHS = (/0,0,0,0,0,0,0,0,1/)
      else if(myrank.eq.1)then
        IRN_loc =  (/3,4,5,3,5/)
c        INTERFACE_loc =  (/.true.,.false.,.true.,.true.,.true./)
        JCN_loc =  (/3,4,5,5,3/)
        A_loc =  (/1.d0,1.0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.2)then
        IRN_loc =  (/5,6,7,5,7/)
c        INTERFACE_loc =  (/.true.,.false.,.true.,.true.,.true./)
        JCN_loc =  (/5,6,7,7,5/)
        A_loc =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.3)then
        IRN_loc =  (/7,8,9,7,9/)
c        INTERFACE_loc =  (/.true.,.false.,.true.,.true.,.true./)
        JCN_loc =  (/7,8,9,9,7/)
        A_loc =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,0.d0/)
      endif
      end subroutine fill_interface
c---------------------------------------------------------------------
      subroutine compare_ints(size,tab1,tab2,result)
      implicit none
      integer :: size
      integer, dimension(:), pointer :: tab1
      integer, dimension(:), pointer :: tab2
      integer :: result
      integer :: i
      result = 1
      do i=1,size
         if(tab1(i).ne.tab2(i))then
           result = 0
         endif
      enddo
      if(result.eq.0)then
        write(*,*)tab1(1:size)
        write(*,*)tab2(1:size)
      endif
      end subroutine compare_ints
c---------------------------------------------------------------------
      subroutine compare_ints2(size,tab1,tab2,result)
      implicit none
      integer :: size
      integer, dimension(:), pointer :: tab1
      integer, dimension(:), pointer :: tab2
      integer :: result
      integer :: i
      result = 1
      do i=1,size
         if(tab1(i).ne.tab2(i))then
           result = 0
         endif
      enddo
      if(result.eq.0)then
        write(*,*)tab1(1:size)
        write(*,*)tab2(1:size)
      endif
      end subroutine compare_ints2
c---------------------------------------------------------------------
      subroutine compare_doubles(size,tab1,tab2,result)
      implicit none
      integer :: size
      double precision, dimension(:), pointer :: tab1
      double precision, dimension(:), pointer :: tab2
      integer :: result
      integer :: i
      result = 1
      do i=1,size
         if(abs(tab1(i)-tab2(i)).gt.1.d-8)then
           result = 0
         endif
      enddo
      if(result.eq.0)then
        write(*,*)tab1(1:size)
        write(*,*)tab2(1:size)
      endif
      end subroutine compare_doubles
c---------------------------------------------------------------------
      subroutine compare_doubles2(size,tab1,tab2,result)
      implicit none
      integer :: size
      double precision, dimension(:), pointer :: tab1
      double precision, dimension(:), pointer :: tab2
      integer :: result
      integer :: i
      result = 1
      do i=1,size
         if(abs(tab1(i)-tab2(i)).gt.1.d-8)then
           result = 0
         endif
      enddo
      if(result.eq.0)then
        write(*,*)tab1(1:size)
        write(*,*)tab2(1:size)
      endif
      end subroutine compare_doubles2
c---------------------------------------------------------------------
      subroutine compare_logicals(size,tab1,tab2,result)
      implicit none
      integer :: size
      logical, dimension(:), pointer :: tab1
      logical, dimension(:), pointer :: tab2
      integer :: result
      integer :: i
      result = 1
      do i=1,size
         if(tab1(i).neqv.tab2(i))then
           result = 0
         endif
      enddo
      if(result.eq.0)then
        write(*,*)tab1(1:size)
        write(*,*)tab2(1:size)
      endif
      end subroutine compare_logicals
c---------------------------------------------------------------------
      subroutine test_phaseI_1
      implicit none
      integer :: i1,i2
      integer :: local_nrproc,local_rank
      write(*,*)'test phaseI_1_create_communicators'
      call phaseI_1_create_communicators
      call mpi_comm_size(COMM_LOC,local_nrproc,i1)
      call mpi_comm_rank(COMM_LOC,local_rank,i2)
      if(local_nrproc.ne.1.or.local_rank.ne.0)then
        write(*,*)'phaseI_1:error',local_nrproc,local_rank
      endif
      end subroutine test_phaseI_1
c---------------------------------------------------------------------
      subroutine test_phaseI_2
      write(*,*)'test phaseI_2_create_local_mumps'
      call phaseI_2_create_local_mumps
      end subroutine test_phaseI_2
c---------------------------------------------------------------------
      subroutine test_phaseI_3
      implicit none
      integer :: ires
      write(*,*)'test phaseI_3_translate_global_to_local'
      call phaseI_3_translate_global_to_local
c testing
      allocate(test_IRN_loc_sorted(NZ_loc))
      allocate(test_INTERFACE_loc_sorted(NZ_loc))
      allocate(test_JCN_loc_sorted(NZ_loc))
      allocate(test_IRN_loc_sorted_ptr(NZ_loc))
      allocate(test_JCN_loc_sorted_ptr(NZ_loc))
      allocate(test_mapl2g(3))
      if(myrank.eq.0)then
        test_IRN_loc_sorted =  (/1,1,2,3,3/)
        test_INTERFACE_loc_sorted = 
     .    (/.true.,.true.,.false.,.true.,.true./)
        test_JCN_loc_sorted =  (/1,1,2,3,3/)
        test_IRN_loc_sorted_ptr =  (/4,1,2,5,3/)
        test_JCN_loc_sorted_ptr =  (/5,1,2,4,3/)
        test_mapl2g =  (/1,2,3/)
      else if(myrank.eq.1)then
        test_IRN_loc_sorted =  (/3,3,4,5,5/)
        test_INTERFACE_loc_sorted = 
     .    (/.true.,.true.,.false.,.true.,.true./)
        test_JCN_loc_sorted =  (/3,3,4,5,5/)
        test_IRN_loc_sorted_ptr =  (/4,1,2,5,3/)
        test_JCN_loc_sorted_ptr =  (/5,1,2,4,3/)
        test_mapl2g =  (/3,4,5/)
      else if(myrank.eq.2)then
        test_IRN_loc_sorted =  (/5,5,6,7,7/)
        test_INTERFACE_loc_sorted = 
     .    (/.true.,.true.,.false.,.true.,.true./)
        test_JCN_loc_sorted =  (/5,5,6,7,7/)
        test_IRN_loc_sorted_ptr =  (/4,1,2,5,3/)
        test_JCN_loc_sorted_ptr =  (/5,1,2,4,3/)
        test_mapl2g =  (/5,6,7/)
      else if(myrank.eq.3)then
        test_IRN_loc_sorted =  (/7,7,8,9,9/)
        test_INTERFACE_loc_sorted = 
     .    (/.true.,.true.,.false.,.true.,.true./)
        test_JCN_loc_sorted =  (/7,7,8,9,9/)
        test_IRN_loc_sorted_ptr =  (/4,1,2,5,3/)
        test_JCN_loc_sorted_ptr =  (/5,1,2,4,3/)
        test_mapl2g =  (/7,8,9/)
      endif
      call compare_ints(5,IRN_loc_sorted,test_IRN_loc_sorted,ires)
      if(ires.eq.0)write(*,*)'error in IRN_loc_sorted'
      call compare_ints(5,JCN_loc_sorted,test_JCN_loc_sorted,ires)
      if(ires.eq.0)write(*,*)'error in JCN_loc_sorted'
      call compare_ints
     .  (5,IRN_loc_sorted_ptr,test_IRN_loc_sorted_ptr,ires)
      if(ires.eq.0)write(*,*)'error in IRN_loc_sorted_ptr'
      call compare_ints
     .  (5,JCN_loc_sorted_ptr,test_JCN_loc_sorted_ptr,ires)
      if(ires.eq.0)write(*,*)'error in JCN_loc_sorted_ptr'
      call compare_logicals
     .  (5,INTERFACE_loc_sorted,test_INTERFACE_loc_sorted,ires)
      if(ires.eq.0)write(*,*)'error in INTERFACE_loc_sorted'
      call compare_ints
     .  (3,mapl2g,test_mapl2g,ires)
      if(ires.eq.0)write(*,*)'error in mapl2g'
      deallocate(test_IRN_loc_sorted)
      deallocate(test_INTERFACE_loc_sorted)
      deallocate(test_JCN_loc_sorted)
      deallocate(test_IRN_loc_sorted_ptr)
      deallocate(test_JCN_loc_sorted_ptr)
      deallocate(test_mapl2g)

c      call compare_logicals
c     .  (5,INTERFACE_loc,INTERFACE_loc2,ires)
c      if(ires.eq.0)write(*,*)'error in INTERFACE_loc2'
c test mumps
      allocate(test_IRN(5))
      test_IRN =  (/1,2,3,1,3/)
      call compare_ints2(5,mumps_phaseI%IRN,test_IRN,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%IRN'
      deallocate(test_IRN)
c
      allocate(test_JCN(5))
      test_JCN =  (/1,2,3,3,1/)
      call compare_ints2(5,mumps_phaseI%JCN,test_JCN,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%JCN'
      deallocate(test_JCN)
      end subroutine test_phaseI_3
c-------------------------------------------------------------------
      subroutine test_phaseI_3a
      write(*,*)'test phaseI_3a_cleanup'
      call phaseI_3a_cleanup
      if(associated(IRN_loc))
     .  write(*,*)'error deallocation IRN_loc'
      if(associated(JCN_loc))
     .  write(*,*)'error deallocation JCN_loc'
      end subroutine test_phaseI_3a
c------------------------------------------------------------------
      subroutine test_phaseI_3prim
      implicit none
      integer :: ires
      write(*,*)'test phaseI_3prim_distribute_rhs'
      call phaseI_3prim_distribute_rhs
      
      allocate(test_RHS_loc(3))
      if(myrank.eq.0)then
        allocate(test_maps_sizes(4))
        allocate(test_mapsl2g(12))
        test_maps_sizes =  (/3,3,3,3/)
        test_mapsl2g = (/1,2,3,3,4,5,5,6,7,7,8,9/)
        call compare_ints(4,maps_sizes,test_maps_sizes,ires)
        if(ires.eq.0)write(*,*)'error in maps_sizes'
        call compare_ints(12,mapsl2g,test_mapsl2g,ires)
        if(ires.eq.0)write(*,*)'error in mapsl2g'
        deallocate(test_maps_sizes)
        deallocate(test_mapsl2g)
        test_RHS_loc =  (/0,0,0/)
      else if(myrank.eq.1)then
        test_RHS_loc =  (/0,0,0/)
      else if(myrank.eq.2)then
        test_RHS_loc =  (/0,0,0/)
      else if(myrank.eq.3)then
        test_RHS_loc =  (/0,0,1/)
      endif
      call compare_doubles(3,RHS_loc,test_RHS_loc,ires)
      if(ires.eq.0)write(*,*)'error in RHS_loc'
      deallocate(test_RHS_loc)
      end subroutine test_phaseI_3prim
c------------------------------------------------------------------
      subroutine test_phaseI_4
      implicit none
      integer :: ires
      write(*,*)'test phaseI_4_submit_Schur_to_mumps'
      call phaseI_4_submit_Schur_to_mumps
      
      if(mumps_phaseI%N.ne.3)write(*,*)'error in mumps_phaseI%N',
     .  mumps_phaseI%N
      if(mumps_phaseI%NZ.ne.5)write(*,*)'error in mumps_phaseI%NZ',
     .  mumps_phaseI%NZ
      if(mumps_phaseI%SIZE_SCHUR.ne.2)write(*,*)
     .  'error in mumps_phaseI%SIZE_SCHUR',mumps_phaseI%SIZE_SCHUR
      allocate(test_LISTVAR_SCHUR(2))
      test_LISTVAR_SCHUR = (/1,3/)
      call compare_ints2
     .  (2,mumps_phaseI%LISTVAR_SCHUR,test_LISTVAR_SCHUR,ires)
      if(ires.eq.0)write(*,*)'error in mumps_phaseI%LISTVAR_SCHUR'
      deallocate(test_LISTVAR_SCHUR)
c test mumps 
      allocate(test_A(5))
      if(myrank.eq.0)then
        test_A =  (/1,1,1,0,-1/)
      else if(myrank.eq.1)then
        test_A =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.2)then
        test_A =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.3)then
        test_A =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,0.d0/)
      endif
      call compare_doubles2(5,mumps_phaseI%A,test_A,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%A'
      deallocate(test_A)
c      write(*,*)myrank,'mumps_phaseI%IRN',mumps_phaseI%IRN
c      write(*,*)myrank,'mumps_phaseI%JCN',mumps_phaseI%JCN
c      write(*,*)myrank,'mumps_phaseI%A',mumps_phaseI%A

      end subroutine test_phaseI_4
c------------------------------------------------------------------
      subroutine test_phaseI_4a
      implicit none
      write(*,*)'test phaseI_4a_cleanup'
      call phaseI_4a_cleanup
c      if(associated(IRN_loc_sorted))
c     .  write(*,*)'error deallocation IRN_loc_sorted'
      if(associated(IRN_loc_sorted_ptr))
     .  write(*,*)'error deallocation IRN_loc_sorted_ptr'
      if(associated(JCN_loc_sorted))
     .  write(*,*)'error deallocation JCN_loc_sorted'
      if(associated(JCN_loc_sorted_ptr))
     .  write(*,*)'error deallocation JCN_loc_sorted_ptr'
      if(associated(A_loc))
     .  write(*,*)'error deallocation A_loc'
      end subroutine test_phaseI_4a
c------------------------------------------------------------------
      subroutine test_phaseI_5
      implicit none
      integer :: ires
      write(*,*)'test phaseI_5_compute_Schur'
      call  phaseI_5_compute_Schur
      
c ......check Schur complement
      allocate(test_SCHUR(4))
      if(myrank.eq.0)then
      test_SCHUR = (/1.d0,0.d0,-1.d0,1.d0/)
      else if(myrank.eq.1)then
      test_SCHUR = (/1.d0,-1.d0,-1.d0,1.d0/)
      else if(myrank.eq.2)then
      test_SCHUR = (/1.d0,-1.d0,-1.d0,1.d0/)
      else if(myrank.eq.3)then
      test_SCHUR = (/1.d0,-1.d0,0.d0,1.d0/)
      endif
      call compare_doubles2
     .  (4,mumps_phaseI%SCHUR,test_SCHUR,ires)
      if(ires.eq.0)write(*,*)'error in mumps_phaseI%SCHUR'
      deallocate(test_SCHUR)
      end subroutine test_phaseI_5
c------------------------------------------------------------------
      subroutine test_phaseI_6
      implicit none
      include "mpif.h"
      integer :: ires
      integer :: isize
      integer :: iprint
      iprint=0
      if(iprint.eq.1)then
      write(*,*)'before test phaseI_6_get_Schur'
      write(*,*)'mumps_phaseI%N',mumps_phaseI%N
      write(*,*)'mumps_phaseI%NZ',mumps_phaseI%NZ
      write(*,*)'mumps_phaseI%IRN',mumps_phaseI%IRN
      write(*,*)'mumps_phaseI%JCN',mumps_phaseI%JCN
      write(*,*)'mumps_phaseI%A',mumps_phaseI%A
      write(*,*)'mumps_phaseI%NZ_loc',mumps_phaseI%NZ_loc
      write(*,*)'mumps_phaseI%IRN_loc',mumps_phaseI%IRN_loc
      write(*,*)'mumps_phaseI%JCN_loc',mumps_phaseI%JCN_loc
      write(*,*)'mumps_phaseI%A_loc',mumps_phaseI%A_loc
      write(*,*)'mumps_phaseI%SIZE_SCHUR',mumps_phaseI%SIZE_SCHUR
      write(*,*)'mumps_phaseI%LISTVAR_SCHUR',mumps_phaseI%LISTVAR_SCHUR
      write(*,*)'mumps_phaseI%SCHUR',mumps_phaseI%SCHUR
      endif
      write(*,*)'test phaseI_6_get_Schur'
      call phaseI_6_get_Schur      
      allocate(test_SCHUR_IRN_loc(4))
      allocate(test_SCHUR_JCN_loc(4))
      allocate(test_SCHUR_A_loc(4))
      allocate(test_SCHUR_RHS_loc(2))
      if(myrank.eq.0)then
        test_SCHUR_IRN_loc =  (/1,3,3/)
        test_SCHUR_JCN_loc =  (/1,1,3/)
        test_SCHUR_A_loc =  (/1,-1,1/)
        test_SCHUR_RHS_loc =  (/0,0/)
        isize=3
      else if(myrank.eq.1)then
        test_SCHUR_IRN_loc =  (/3,5,3,5/)
        test_SCHUR_JCN_loc =  (/3,3,5,5/)
        test_SCHUR_A_loc =  (/1,-1,-1,1/)
        test_SCHUR_RHS_loc =  (/0,0/)
        isize=4
      else if(myrank.eq.2)then
        test_SCHUR_IRN_loc =  (/5,7,5,7/)
        test_SCHUR_JCN_loc =  (/5,5,7,7/)
        test_SCHUR_A_loc =  (/1,-1,-1,1/)
        test_SCHUR_RHS_loc =  (/0,0/)
        isize=4
      else if(myrank.eq.3)then
        test_SCHUR_IRN_loc =  (/7,7,9/)
        test_SCHUR_JCN_loc =  (/7,9,9/)
        test_SCHUR_A_loc =  (/1,-1,1/)
        test_SCHUR_RHS_loc =  (/0,1/)
        isize=3
      endif
      call compare_ints
     .  (isize,SCHUR_IRN_loc,test_SCHUR_IRN_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in SCHUR_IRN_loc'
      call compare_ints
     .  (isize,SCHUR_JCN_loc,test_SCHUR_JCN_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in SCHUR_JCN_loc'
      call compare_doubles
     .  (isize,SCHUR_A_loc,test_SCHUR_A_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in SCHUR_A_loc'
      call compare_doubles
     .  (2,SCHUR_RHS_loc,test_SCHUR_RHS_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in SCHUR_RHS_loc'
      deallocate(test_SCHUR_IRN_loc)
      deallocate(test_SCHUR_JCN_loc)
      deallocate(test_SCHUR_A_loc)
      deallocate(test_SCHUR_RHS_loc)
      end subroutine test_phaseI_6
c------------------------------------------------------------------
      subroutine test_phaseI_6prim
      implicit none
      integer :: ires
      write(*,*)'test phaseI_6prim_copy_local_system'
      call phaseI_6prim_copy_local_system
      
      allocate(test_IRN(5))
      allocate(test_JCN(5))
      allocate(test_A(5))
      if(myrank.eq.0)then
        test_IRN =  (/1,2,3,1,3/)
        test_JCN =  (/1,2,3,3,1/)
      else if(myrank.eq.1)then
        test_IRN =  (/1,2,3,1,3/)
        test_JCN =  (/1,2,3,3,1/)
      else if(myrank.eq.2)then
        test_IRN =  (/1,2,3,1,3/)
        test_JCN =  (/1,2,3,3,1/)
      else if(myrank.eq.3)then
        test_IRN =  (/1,2,3,1,3/)
        test_JCN =  (/1,2,3,3,1/)
      endif
      call compare_ints
     .  (5,IRN_loc2,test_IRN,ires)
      if(ires.eq.0)write(*,*)'error in IRN_loc'
      call compare_ints
     .  (5,JCN_loc2,test_JCN,ires)
      if(ires.eq.0)write(*,*)'error in JCN_loc'
      if(myrank.eq.0)then
        test_A =  (/1,1,1,0,-1/)
      else if(myrank.eq.1)then
        test_A =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.2)then
        test_A =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,-1.d0/)
      else if(myrank.eq.3)then
        test_A =  (/1.d0,1.d0/3.d0,1.d0,-1.d0,0.d0/)
      endif
      call compare_doubles
     .  (5,A_loc,test_A,ires)
      if(ires.eq.0)write(*,*)myrank,'error in A_loc'
      deallocate(test_IRN)
      deallocate(test_JCN)
      deallocate(test_A) 
      end subroutine test_phaseI_6prim
c------------------------------------------------------------------
      subroutine test_phaseI_6a
      implicit none
      write(*,*)'test phaseI_6a_cleanup_mumps'
      call phaseI_6a_cleanup_mumps
      end subroutine test_phaseI_6a
c------------------------------------------------------------------
      subroutine test_phaseI_7
      implicit none
      write(*,*)'test phaseI_7_create_global_mumps'
      call phaseI_7_create_global_mumps
      end subroutine test_phaseI_7
c------------------------------------------------------------------
      subroutine test_phaseI_8
      implicit none
      integer :: ires
      integer :: isize
      write(*,*)'test phaseI_8_submit_Schur_to_global_mumps'
      call phaseI_8_submit_Schur_to_global_mumps
      if(SIZE_SCHUR.ne.2)
     .   write(*,*)'error in SIZE_SCHUR',SIZE_SCHUR
      if(myrank.eq.0)then
      allocate(test_RHS(9))
      if(myrank.eq.0)then
      if(mumps_global%NZ_loc.ne.4)
     .   write(*,*)'error in mumps_global%NZ_loc',mumps_global%NZ_loc
        test_RHS =  (/0,0,0,0,0,0,0,0,1/)
      else if(myrank.eq.1)then
      if(mumps_global%NZ_loc.ne.5)
     .   write(*,*)'error in mumps_global%NZ_loc',mumps_global%NZ_loc
        test_RHS =  (/0,0,0,0,0,0,0,0,0/)
      else if(myrank.eq.2)then
      if(mumps_global%NZ_loc.ne.5)
     .   write(*,*)'error in mumps_global%NZ_loc',mumps_global%NZ_loc
        test_RHS =  (/0,0,0,0,0,0,0,0,0/)
      else if(myrank.eq.3)then
      if(mumps_global%NZ_loc.ne.4)
     .   write(*,*)'error in mumps_global%NZ_loc',mumps_global%NZ_loc
        test_RHS =  (/0,0,0,0,0,0,0,0,1/)
      endif
      call compare_doubles2
     .  (9,mumps_global%RHS,test_RHS,ires)      
      if(ires.eq.0)write(*,*)myrank,'error in mumps_global%RHS'
      deallocate(test_RHS)
      endif
      write(*,*)'test mumps_global%*_loc'
      allocate(test_IRN_loc(5))
      allocate(test_JCN_loc(5))
      allocate(test_A_loc(5))
      if(myrank.eq.0)then
        test_IRN_loc =  (/1,3,3,2/)
        test_JCN_loc =  (/1,1,3,2/)
        test_A_loc =  (/1,-1,1,1/)
        isize=4
      else if(myrank.eq.1)then
        test_IRN_loc =  (/3,5,3,5,4/)
        test_JCN_loc =  (/3,3,5,5,4/)
        test_A_loc =  (/1,-1,-1,1,1/)
        isize=5
      else if(myrank.eq.2)then
        test_IRN_loc =  (/5,7,5,7,6/)
        test_JCN_loc =  (/5,5,7,7,6/)
        test_A_loc =  (/1,-1,-1,1,1/)
        isize=5
      else if(myrank.eq.3)then
        test_IRN_loc =  (/7,7,9,8/)
        test_JCN_loc =  (/7,9,9,8/)
        test_A_loc =  (/1,-1,1,1/)
        isize=4
      endif
      call compare_ints2
     .  (isize,mumps_global%IRN_loc,test_IRN_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in IRN_loc'
      call compare_ints2
     .  (isize,mumps_global%JCN_loc,test_JCN_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in JCN_loc'
      call compare_doubles2
     .  (isize,mumps_global%A_loc,test_A_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in A_loc'
      deallocate(test_IRN_loc)
      deallocate(test_JCN_loc)
      deallocate(test_A_loc)
      end subroutine test_phaseI_8
c-----------------------------------------------------------------
      subroutine test_phaseI_8a
      end subroutine test_phaseI_8a
c------------------------------------------------------------------
      subroutine test_phaseI_9
      implicit none
      integer :: ires
      write(*,*)'test phaseI_9_global_solution'
      call phaseI_9_global_solution
      if(myrank.eq.0)then
         allocate(test_RHS(9))
         test_RHS=(/0.d0,0.d0,0.25d0,0.d0,0.5d0,0.d0,0.75d0,0.d0,1.d0/)
         call compare_doubles2
     .    (9,mumps_global%RHS,test_RHS,ires)
         if(ires.eq.0)write(*,*)'error in mumps_global%RHS'
         deallocate(test_RHS)
      endif      
      end subroutine test_phaseI_9
c------------------------------------------------------------------
      subroutine test_phaseI_10
      implicit none
      integer :: ires
      write(*,*)'test phaseI_10_scatter_solution'
      call phaseI_10_scatter_solution
      allocate(test_SOL_loc(3))
      if(myrank.eq.0)then
        test_SOL_loc =  (/0.d0,0.d0,0.25d0/)
      else if(myrank.eq.1)then
        test_SOL_loc =  (/0.d0,0.d0,0.25d0/)
      else if(myrank.eq.2)then
        test_SOL_loc =  (/0.25d0,0.d0,0.5d0/)
      else if(myrank.eq.3)then
        test_SOL_loc =  (/0.5d0,0.d0,0.75d0/)
      endif
      call compare_doubles
     .  (3,SOL_loc,test_SOL_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in SOL_loc'
      deallocate(test_SOL_loc)
      end subroutine test_phaseI_10
c------------------------------------------------------------------
      subroutine test_phaseI_10a
      write(*,*)'test phaseI_10a_cleanup_global_mumps'
      call phaseI_10a_cleanup_global_mumps
      end subroutine test_phaseI_10a
c------------------------------------------------------------------
      subroutine test_phaseI_11
      write(*,*)'test phaseI_11_initialize_mumps_for_local_solve'
      call phaseI_11_initialize_mumps_for_local_solve
      end subroutine test_phaseI_11
c------------------------------------------------------------------
      subroutine test_phaseI_12
      implicit none
      integer :: ires
      write(*,*)'test phaseI_12_submit_problem_to_mumps'
      call phaseI_12_submit_problem_to_mumps
      allocate(test_IRN_loc(3))
      allocate(test_JCN_loc(3))
      allocate(test_A_loc(3))
      if(myrank.eq.0)then
        test_IRN_loc =  (/3,2,3/)
        test_JCN_loc =  (/3,2,3/)
        test_A_loc =  (/1.d0,1.d0,1.d0/)
      else if(myrank.eq.1)then
        test_IRN_loc =  (/3,2,3/)
        test_JCN_loc =  (/3,2,3/)
        test_A_loc =  (/1.d0,1.d0,1.d0/)
      else if(myrank.eq.2)then
        test_IRN_loc =  (/3,2,3/)
        test_JCN_loc =  (/3,2,3/)
        test_A_loc =  (/1.d0,1.d0,1.d0/)
      else if(myrank.eq.3)then
        test_IRN_loc =  (/3,2,3/)
        test_JCN_loc =  (/3,2,3/)
        test_A_loc =  (/1.d0,1.d0,1.d0/)
      endif
      call compare_ints2
     .  (3,mumps_phaseI%IRN,test_IRN_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%IRN'
      call compare_ints2
     .  (3,mumps_phaseI%JCN,test_JCN_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%JCN'
      call compare_doubles2
     .  (3,mumps_phaseI%A,test_A_loc,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%A'
      deallocate(test_IRN_loc)
      deallocate(test_JCN_loc)
      deallocate(test_A_loc)      
      end subroutine test_phaseI_12
c------------------------------------------------------------------
      subroutine test_phaseI_12a      
      implicit none
      write(*,*)'test phaseI_12a_cleanup'
      call phaseI_12a_cleanup
      if(associated(IRN_loc_sorted))
     .  write(*,*)'error deallocation IRN_loc_sorted'
      if(associated(INTERFACE_loc_sorted))write(*,*)
     .  'error deallocation INTERFACE_loc_sorted'
      if(associated(SOL_loc))write(*,*)
     .  'error deallocation SOL_loc'
      if(associated(RHS_loc))write(*,*)
     .  'error deallocation RHS_loc'
      if(associated(IRN_loc))write(*,*)
     .  'error deallocation IRN_loc'
      if(associated(JCN_loc))write(*,*)
     .  'error deallocation JCN_loc'
      if(associated(A_loc))write(*,*)
     .  'error deallocation A_loc'
      end subroutine test_phaseI_12a
c------------------------------------------------------------------
      subroutine test_phaseI_13
      implicit none
      integer :: ires
      write(*,*)'test phaseI_13_compute'
      call phaseI_13_compute
      allocate(test_RHS(3))
      if(myrank.eq.0)then
        test_RHS =  (/0.d0,0.d0,0.25d0/)
      else if(myrank.eq.1)then
        test_RHS =  (/0.d0,0.d0,0.25d0/)
      else if(myrank.eq.2)then
        test_RHS =  (/0.25d0,0.d0,0.5d0/)
      else if(myrank.eq.3)then
        test_RHS =  (/0.5d0,0.d0,0.75d0/)
      endif
      call compare_doubles2
     .  (3,mumps_phaseI%RHS,test_RHS,ires)
      if(ires.eq.0)write(*,*)myrank,'error in mumps_phaseI%RHS'
      deallocate(test_RHS)
      end subroutine test_phaseI_13
c------------------------------------------------------------------
      subroutine test_phaseI_14
      implicit none
      integer :: ires
      write(*,*)'test phaseI_14_return_solution'
      call phaseI_14_return_solution
      if(myrank.eq.0)then
        allocate(test_RHS(9))
        test_RHS=(/0.d0,0.d0,0.25d0,0.d0,0.5d0,0.d0,0.75d0,0.d0,1.d0/)
        call compare_doubles
     .  (9,RHS,test_RHS,ires)
        if(ires.eq.0)write(*,*)'error in RHS'
        deallocate(test_RHS)
      endif
      end subroutine test_phaseI_14
c--------------------------------------------------------------------
      subroutine test_phaseI_14a
      implicit none
      write(*,*)'test phaseI_14a_shutdown'
      call phaseI_14a_shutdown
      if(associated(mapl2g))
     .  write(*,*)'error in deallocation mapl2g'
      if(associated(mapsl2g))
     .  write(*,*)'error in deallocation mapsl2g'
      if(associated(maps_sizes))
     .  write(*,*)'error in deallocation maps_sizes'
      if(associated(IRN_loc_sorted))
     .  write(*,*)'error in deallocation IRN_loc_sorted'
      if(associated(IRN_loc_sorted_ptr))
     .  write(*,*)'error in deallocation IRN_loc_sorted_ptr'
      if(associated(JCN_loc_sorted))
     .  write(*,*)'error in deallocation JCN_loc_sorted'
      if(associated(JCN_loc_sorted_ptr))
     .  write(*,*)'error in deallocation JCN_loc_sorted_ptr'
      if(associated(INTERFACE_loc_sorted))
     .  write(*,*)'error in deallocation INTERFACE_loc_sorted'
      if(associated(SCHUR_IRN_loc))
     .  write(*,*)'error in deallocation SCHUR_IRN_loc'
      if(associated(SCHUR_JCN_loc))
     .  write(*,*)'error in deallocation SCHUR_JCN_loc'
      if(associated(SCHUR_A_loc))
     .  write(*,*)'error in deallocation SCHUR_A_loc'
      if(associated(SOL_part))
     .  write(*,*)'error in deallocation SOL_part'
      end subroutine test_phaseI_14a
c------------------------------------------------------------------
      subroutine run_HMS_tests
      implicit none
      include "mpif.h"
      integer :: ierr
      call fill_interface
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_1
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_2
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_3
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_3a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_3prim
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_4
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_4a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_5
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_6
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_6prim
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_6a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_7
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_8
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_8a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_9
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_10
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_10a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_11
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_12
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_12a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_13
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_14
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call test_phaseI_14a
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      end subroutine run_HMS_tests
c------------------------------------------------------------------
      end module test_HierarchicalSolver
